-- Filename:     full_adder_ssa.vhd
-- Filetype:     VHDL code (dataflow)
-- Date:         9 feb 2014
-- Update:       -
-- Description:  An example of a full adder
-- Author:       J. op den Brouw
-- State:        demo
-- Error:        -
-- Version:      1.0
-- Copyright:    (c)2014, De Haagse Hogeschool
--
-- This is an example of a full adder using an
-- Selected Signal Assignment. It shows how to
-- implement a logic function using a truth table.
--
-- We need std_logic et al.

library ieee;
use ieee.std_logic_1164.all;

entity full_adder_ssa is
    port (a_b_cin: in std_logic_vector (2 downto 0);
          cout_s : out std_logic_vector (1 downto 0));
end entity full_adder_ssa;

architecture truth_table of full_adder_ssa is
begin
    with a_b_cin select
    cout_s <= "00" when "000",
              "01" when "001",
              "01" when "010",
              "10" when "011",
              "01" when "100",
              "10" when "101",
              "10" when "110",
              "11" when "111",
              "XX" when others;
end architecture truth_table;